require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/qqoqcps', type: :request do
  # Tools::Qqoqcp. As you add validations to Tools::Qqoqcp, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {rca_id: rca.id, tool_reference: 1} }
  let(:invalid_attributes) { {rca_id: nil, tool_reference: 1} }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  context 'From logged user' do
    before :each do
      # binding.pry
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    # describe 'GET /index' do
    #   context 'without rca defined' do
    #     it 'renders a redirection response' do
    #       get tools_qqoqcps_url
    #       # redirection car rca non défini
    #       expect(response).to have_http_status(:redirect)
    #       expect(response).to redirect_to(rcas_path)
    #     end
    #   end

    #   context 'with rca and step_tool defined' do
    #     it 'renders a redirection response' do
    #       get tools_qqoqcps_url, params: {rca: rca.id}
    #       expect(response).to be_successful
    #     end
    #   end
    # end

    # describe 'GET /show' do
    #   it 'renders a successful response' do
    #     tools_qqoqcp = Tools::Qqoqcp.create! valid_attributes
    #     get tools_qqoqcp_url(tools_qqoqcp)
    #     expect(response).to be_successful
    #   end
    # end

    describe 'GET /new' do
      context 'without rca defined' do
        it 'renders a redirection response' do
          get new_tools_qqoqcp_url, params: {}
          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'with rca and step_tool defined' do
        it 'renders a successful response' do
          get new_tools_qqoqcp_url, params: { rca: rca.id }
          expect(response).to be_successful
        end
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_qqoqcp = Tools::Qqoqcp.create! valid_attributes
        get edit_tools_qqoqcp_url(tools_qqoqcp)
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new Tools::Qqoqcp' do
          expect {
            post tools_qqoqcps_url, params: { tools_qqoqcp: valid_attributes }
          }.to change(Tools::Qqoqcp, :count).by(1)
        end

        it 'redirects to the created tools_qqoqcp' do
          post tools_qqoqcps_url, params: { tools_qqoqcp: valid_attributes }
          expect(response).to redirect_to(edit_tools_qqoqcp_url(Tools::Qqoqcp.first.id))
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Tools::Qqoqcp' do
          expect {
            post tools_qqoqcps_url, params: { rca: rca.id, tools_qqoqcp: invalid_attributes }
          }.to change(Tools::Qqoqcp, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post tools_qqoqcps_url, params: { rca: rca.id, tools_qqoqcp: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {qui: 'texte qui'} }

        it 'updates the requested tools_qqoqcp' do
          tools_qqoqcp = Tools::Qqoqcp.create! valid_attributes
          patch tools_qqoqcp_url(tools_qqoqcp), params: { tools_qqoqcp: new_attributes }
          tools_qqoqcp.reload
          expect(tools_qqoqcp.qui).to eq('texte qui')
        end

        it 'redirects to the edit tools_qqoqcp action' do
          tools_qqoqcp = Tools::Qqoqcp.create! valid_attributes
          patch tools_qqoqcp_url(tools_qqoqcp), params: { tools_qqoqcp: new_attributes }
          tools_qqoqcp.reload
          expect(response).to redirect_to(meth_step_tool_show_path(id: user.get_session(:active_step_tool), rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_qqoqcp = Tools::Qqoqcp.create! valid_attributes
          patch tools_qqoqcp_url(tools_qqoqcp), params: { tools_qqoqcp: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested tools_qqoqcp' do
        tools_qqoqcp = Tools::Qqoqcp.create! valid_attributes
        expect {
          delete tools_qqoqcp_url(tools_qqoqcp)
        }.to change(Tools::Qqoqcp, :count).by(-1)
      end

      it 'redirects to the tools_qqoqcps list' do
        tools_qqoqcp = Tools::Qqoqcp.create! valid_attributes
        delete tools_qqoqcp_url(tools_qqoqcp), params: { rca: rca }
        expect(response).to redirect_to(tools_qqoqcps_url(rca: rca))
      end
    end
  end
end
